! This soubroutine calculates the EmaxV by interpolation (BEmax_val is the input)

MODULE Emax_int


IMPLICIT NONE 


CONTAINS

! ------------------------------------------------------------------------------------------------------------
! (2)EmaxV
!EmaxV(id,tt, ksi, xx, loc, Ea, Va, bigJ, bigG,sch, enrolled, progress) 
!(student id, time period, type, s, location, crime history, bigJ: arrest and jail history, grade, school id, whether or not enrolled last period,whether or not to proceed one grade)

! It uses: Beta_DPP(dim_betas,bigS2,bigT-1,SizeDimXX,Ntype,Nloc)    
	
FUNCTION EmaxV(id_aux,tt, ksi, xx, loc, Ea, Va,  bigJ, bigG, sch, enroll, progress) 

! ------------------------------------------------------------------------------------------------------------
! It calculates the Emax
! ------------------------------------------------------------------------------------------------------------
 
USE MATRIX
USE variables
USE random
USE OLS_interpolation


IMPLICIT  NONE

    INTEGER, INTENT(IN)    :: id_aux, tt, ksi, loc, bigJ(2), bigG, sch, enroll, progress
    double precision, INTENT(IN)    :: xx(dim_x), Ea, Va
    double precision  :: EmaxV,  XVarI(1,dim_SSpace), XXVarT(1,dim_SSpace+1), XXVar(1,dim_betas), Baux(dim_betas,1), &
                         BauxT(dim_SSpace+1,1)   
    double precision, external:: terminalV    
    INTEGER  :: ii_sch2, W_inter(2)

!---------------------------------------------------------------------------------------------------------------------------
!        -   Interpolation
!---------------------------------------------------------------------------------------------------------------------------
  
if (bigG < Gstar) then 	
  W_inter(1:2)=nint(W(1:2,sch))
else
  W_inter(1:2)=nint(W(7:8,sch))
endif	  


    
if (W_inter(1)==0 .and. W_inter(2)==1) then 
  ii_sch2=1
elseif (W_inter(1)==0 .and. W_inter(2)==2) then
  ii_sch2=2
elseif (W_inter(1)==0 .and. W_inter(2)==3) then
  ii_sch2=3  
elseif (W_inter(1)==1 .and. W_inter(2)==1) then
  ii_sch2=4
elseif (W_inter(1)==1 .and. W_inter(2)==2) then
  ii_sch2=5 
elseif (W_inter(1)==1 .and. W_inter(2)==3) then
  ii_sch2=6    
endif
    
if (tt==bigT+1) then	
  
  if (bigG < Gstar) then 
     EmaxV=terminalV(ksi, xx, loc, Ea, Va, bigJ, bigG, W(1:6,sch))
  else
  	 EmaxV=terminalV(ksi, xx, loc, Ea, Va, bigJ, bigG, W(7:12,sch))
  endif

else 	

  
  XVarI(1,1)=exp(Ea); XVarI(1,2)=Va; XVarI(1,3)=bigJ(1); XVarI(1,4)=bigJ(2); XVarI(1,5)=bigG;
  XVarI(1,10)=enroll;  XVarI(1,11)=progress;
  if (bigG < Gstar) then 	
    XVarI(1,6)=exp(W(3,sch)); XVarI(1,7)=W(4,sch); XVarI(1,8)=W(5,sch); XVarI(1,9)=0.0d-0;   
  else 
    XVarI(1,6)=exp(W(9,sch)); XVarI(1,7)=W(10,sch); XVarI(1,8)=W(11,sch); XVarI(1,9)=1.0d-0;   
  endif
  
  XXVar(1,1:11)=XVarI(1,1:11)
  XXVar(1,12:19)=XVarI(1,1:8)**dble(2) 

  XXVar(1,20)=XVarI(1,1)*XVarI(1,2)
  XXVar(1,21)=XVarI(1,1)*XVarI(1,3)
  XXVar(1,22)=XVarI(1,1)*XVarI(1,4)
  XXVar(1,23)=XVarI(1,1)*XVarI(1,5)
  XXVar(1,24)=XVarI(1,1)*XVarI(1,6)
  XXVar(1,25)=XVarI(1,1)*XVarI(1,7)
  XXVar(1,26)=XVarI(1,1)*XVarI(1,8)
  XXVar(1,27)=XVarI(1,1)*XVarI(1,9)
  XXVar(1,28)=XVarI(1,1)*XVarI(1,10)
  XXVar(1,29)=XVarI(1,1)*XVarI(1,11)

  XXVar(1,30)=XVarI(1,2)*XVarI(1,3)
  XXVar(1,31)=XVarI(1,2)*XVarI(1,4)
  XXVar(1,32)=XVarI(1,2)*XVarI(1,5)
  XXVar(1,33)=XVarI(1,2)*XVarI(1,6)
  XXVar(1,34)=XVarI(1,2)*XVarI(1,7)
  XXVar(1,35)=XVarI(1,2)*XVarI(1,8)
  XXVar(1,36)=XVarI(1,2)*XVarI(1,9)
  XXVar(1,37)=XVarI(1,2)*XVarI(1,10)
  XXVar(1,38)=XVarI(1,2)*XVarI(1,11)

  XXVar(1,39)=XVarI(1,3)*XVarI(1,4)
  XXVar(1,40)=XVarI(1,3)*XVarI(1,5)
  XXVar(1,41)=XVarI(1,3)*XVarI(1,6)
  XXVar(1,42)=XVarI(1,3)*XVarI(1,7)
  XXVar(1,43)=XVarI(1,3)*XVarI(1,8)
  XXVar(1,44)=XVarI(1,3)*XVarI(1,9)
  XXVar(1,45)=XVarI(1,3)*XVarI(1,10)
  XXVar(1,46)=XVarI(1,3)*XVarI(1,11)

  XXVar(1,47)=XVarI(1,4)*XVarI(1,5)
  XXVar(1,48)=XVarI(1,4)*XVarI(1,6)
  XXVar(1,49)=XVarI(1,4)*XVarI(1,7)
  XXVar(1,50)=XVarI(1,4)*XVarI(1,8)
  XXVar(1,51)=XVarI(1,4)*XVarI(1,9)
  XXVar(1,52)=XVarI(1,4)*XVarI(1,10)
  XXVar(1,53)=XVarI(1,4)*XVarI(1,11)

  XXVar(1,54)=XVarI(1,5)*XVarI(1,6)
  XXVar(1,55)=XVarI(1,5)*XVarI(1,7)
  XXVar(1,56)=XVarI(1,5)*XVarI(1,8)
  XXVar(1,57)=XVarI(1,5)*XVarI(1,9)
  XXVar(1,58)=XVarI(1,5)*XVarI(1,10)
  XXVar(1,59)=XVarI(1,5)*XVarI(1,11)

  XXVar(1,60)=XVarI(1,6)*XVarI(1,7)
  XXVar(1,61)=XVarI(1,6)*XVarI(1,8)
  XXVar(1,62)=XVarI(1,6)*XVarI(1,9)
  XXVar(1,63)=XVarI(1,6)*XVarI(1,10)
  XXVar(1,64)=XVarI(1,6)*XVarI(1,11)

  XXVar(1,65)=XVarI(1,7)*XVarI(1,8)
  XXVar(1,66)=XVarI(1,7)*XVarI(1,9)
  XXVar(1,67)=XVarI(1,7)*XVarI(1,10)
  XXVar(1,68)=XVarI(1,7)*XVarI(1,11)

  XXVar(1,69)=XVarI(1,8)*XVarI(1,9)
  XXVar(1,70)=XVarI(1,8)*XVarI(1,10)
  XXVar(1,71)=XVarI(1,8)*XVarI(1,11)

  XXVar(1,72)=XVarI(1,9)*XVarI(1,10)
  XXVar(1,73)=XVarI(1,9)*XVarI(1,11)

  XXVar(1,74)=XVarI(1,10)*XVarI(1,11)

  XXVar(1,dim_betas)=1.0d-0
 
  
  !Baux(dim_betas,bigS2,bigT-1)
  Baux(:,1)=Beta_DPP(:,ii_sch2,tt-1,id_aux,ksi,loc)        !!! tt-1 because in t=1 is called t+1=2 
  EmaxV=sum(XXVar(1,:)*Baux(:,1),dim=1)

end if

RETURN

END  FUNCTION EmaxV
!---------------------------------------------------------------------------------------------------------------------------
!---------------------------------------------------------------------------------------------------------------------------


END MODULE Emax_int

