program main 
!######################
! This program simulate/estimate a model of decisions on education and crime with learning of one's ability. 
!###############
USE OMP_LIB
USE random
use variables
use objectives
implicit none
integer:: i, s, j,n, np
double precision,allocatable::param(:),para0(:)
double precision:: likely

double precision, allocatable :: p00(:,:), y00(:)
! for shocks
double precision:: r_aux


!Specifies that this is to calculate the likelihood function 
purpose=2
incomecut(1)=35714 	
incomecut(2)=62500
medianInc=41667
Medw3_5=0.21411 
Medw3_10=-0.1176  
P75w6_5=.3898301
P75w6_10=.8039684  
Medgpa= -0.0050951
MedX3=41667
np=tnp
lowGPA=-0.75
! Seed

CALL RANDOM_SEED(size = i_size)
CALL RANDOM_SEED(put = i_seed)
 


! Time counter
CALL SYSTEM_CLOCK(COUNT_RATE = ClockRate_Total)
CALL SYSTEM_CLOCK(COUNT = ClockStartAll_Total)

allocate (X(dim_X,dataN), s0(dataN), oldGPA(dim_oldGPA,dataN),sch0(dataN),hh_loc(dataN),X_girdDP(2,SizeDimXX))
allocate(id_xx(dataN))

!********READ in Data********


open(1,file='DataStudent.txt',status='old')
    if(purpose==1.or.purpose==3) then
        allocate(dEnroll(bigT, dataN),dGPA(bigT, dataN),dbigG(bigT+1, dataN),dArrests(bigT, dataN), dJails(bigT, dataN), dNewschool(dataN))
        do i=1,dataN
            read(1,*)  j, X(:,i), s0(i), oldGPA(:,i),sch0(i), hh_loc(i), dEnroll(:,i), dGPA(:,i), dbigG(:,i), dArrests(:,i), dJails(:,i), dNewschool(i)
        enddo
    else    !do not read in outcomes
        do i=1,dataN	
            read(1,*) j, X(:,i), s0(i), oldGPA(:,i),sch0(i), hh_loc(i)
        enddo
    endif
close(1)


! To define the xx type of each individual
do i=1,dataN
     if (nint(X(1,i))==1 .and. X(3,i)<incomecut(1)) then
       id_xx(i)=1
     elseif (nint(X(1,i))==2 .and. X(3,i)<incomecut(1)) then
       id_xx(i)=2
     elseif (nint(X(1,i))==3 .and. X(3,i)<incomecut(1)) then
       id_xx(i)=3
     elseif (nint(X(1,i))==1 .and. X(3,i)>=incomecut(1) .and. X(3,i)<incomecut(2)) then
       id_xx(i)=4
     elseif (nint(X(1,i))==2 .and. X(3,i)>=incomecut(1) .and. X(3,i)<incomecut(2)) then
       id_xx(i)=5
     elseif (nint(X(1,i))==3 .and. X(3,i)>=incomecut(1) .and. X(3,i)<incomecut(2)) then
       id_xx(i)=6
     elseif (nint(X(1,i))==1 .and. X(3,i)>=incomecut(2)) then
       id_xx(i)=7
     elseif (nint(X(1,i))==2 .and. X(3,i)>=incomecut(2)) then
       id_xx(i)=8
     elseif (nint(X(1,i))==3 .and. X(3,i)>=incomecut(2)) then
       id_xx(i)=9
     endif
enddo


! Stundet Types for the DP
X_girdDP(1,1)=1; X_girdDP(2,1)=1;
X_girdDP(1,2)=2; X_girdDP(2,2)=1;
X_girdDP(1,3)=3; X_girdDP(2,3)=1;
X_girdDP(1,4)=1; X_girdDP(2,4)=2;
X_girdDP(1,5)=2; X_girdDP(2,5)=2;
X_girdDP(1,6)=3; X_girdDP(2,6)=2;
X_girdDP(1,7)=1; X_girdDP(2,7)=3;
X_girdDP(1,8)=2; X_girdDP(2,8)=3;
X_girdDP(1,SizeDimXX)=3; X_girdDP(2,SizeDimXX)=3;


open(1,file='DataSchoolLoc.txt',status='old')
    do i=1,Max_num_sch	
        read(1,*) Mat_sch_loc(i,:)
    enddo
close(1)


open(1,file='DataLoc.txt',status='old')
    do i=1,Nloc
        read(1,*) j, R_arrest(i),R_crime(:,i), frac_goodSchool(i),meaninc(i),N_sch_loc(i)
    enddo
close(1)

            
open(1,file='DataSch.txt',status='old') !rank schools by their locations 
    do j=1,BigS
        read(1,*) i, W(:,j),offerhigh(j),Missing_W(j)
    enddo
Close(1)

!******* Read in out-of-model parameters*******
! read in P_jailtime distribution data
open(1,file='DataJailtime.txt',status='old') 
    do i=0,maxArrest
           do n=1,bigT
                read(1,*) P_Jtime(i,0:maxJ,n)
           enddo
    enddo
close(1)

!********* Read in model parameters*******
allocate(para0(np))
open(1,file='Parameters_L1.txt',status='old') 
    do n=1,tnp
	    read(1,*) para0(n)
    enddo
close(1)


allocate (Aux_Ea_grid(SizeGrid,bigT-1))
allocate (Aux_Va_grid(SizeGrid,bigT-1))  
allocate (Aux_Jgrid1(SizeGrid,bigT-1))  
allocate (Aux_Jgrid2(SizeGrid,bigT-1))  
allocate (Aux_Ggrid(SizeGrid,bigT-1))  
allocate (Aux_Progrid(SizeGrid,bigT-1))  
allocate (Aux_Egrid(SizeGrid,bigT-1))  
allocate (Aux_Test_grid(SizeGrid,bigT-1))  
allocate (Aux_Teacher_grid(SizeGrid,bigT-1))  
allocate (Aux_Cut_grid(SizeGrid,bigT-1))  
allocate (Aux_Tuition_grid(SizeGrid,bigT-1))           

allocate (Aux_gpa_sim(Size_simul_M,bigT-1)) 
        
! Random numbers for the Kean and Wolpin method
DO i=1,SizeGrid
  DO j=1,bigT-1
     CALL RANDOM_NUMBER(r_aux); Aux_Ea_grid(i,j)=r_aux                  !normal
     CALL RANDOM_NUMBER(r_aux); Aux_Va_grid(i,j)=r_aux  ! uniform 
     CALL RANDOM_NUMBER(r_aux); Aux_Jgrid1(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Jgrid2(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Ggrid(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Progrid(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Egrid(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Test_grid(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Teacher_grid(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Cut_grid(i,j)=r_aux
     CALL RANDOM_NUMBER(r_aux); Aux_Tuition_grid(i,j)=r_aux
  ENDDO
ENDDO

DO i=1,Size_simul_M
  DO j=1,bigT-1
  Aux_gpa_sim(i,j)=random_normal() 
  ENDDO
ENDDO

!*****

std_err=0
print*, 'run simulation'
call objective(np,para0,likely)

open(11,file='Time_simulation.txt',status='replace')
    CALL SYSTEM_CLOCK(COUNT = ClockEndAll_Total)
    write(11,*) "Total RunTime for simulation is = ",REAL(ClockEndAll_Total-ClockStartAll_Total)/REAL(ClockRate_Total)
close(11)



end program main
