module objectives
  use variables
  use random
  
  implicit none

contains


subroutine objective(nn,ppara,likely)
USE OMP_LIB
use variables
use Emax_betas
use mt19937a
use normal

implicit none
integer,intent(in)::nn
double precision, intent(in)::ppara(nn)
double precision, intent(out):: likely
integer:: n,m,i,j,t, bb

double precision:: dummy, r_aux
integer:: ir 



CALL RANDOM_SEED(size = i_size)
CALL RANDOM_SEED(put = i_seed)
 
 

likely=0


    n=1
    
sigmaA(1)=dexp(ppara(n))
sigmaA(2:Ntype)=sigmaA(1)    
  do i=1,Ntype
    n=n+1
	meanA(i)=ppara(n)
  enddo
n=n+1
sigma_gpa=dexp(ppara(n))
  do i=1,dim_paraGPA
    n=n+1
	para_GPA(i)=ppara(n)
  enddo
  
  n=n+1
  paraS(0)=ppara(n)
  n=n+1
  paraS(1)=dexp(ppara(n))
  
  do i=1,bigT
    n=n+1
	para_GPA0(i)=ppara(n)
  enddo
    
n=n+1
sigma_pass=dexp(ppara(n))
    
  do i=1,Ntype
	 n=n+1
	 para_Pass(i)=ppara(n)
  enddo
n=n+1
sigma_s0=dexp(ppara(n))
n=n+1
fixcost(1)=dexp(ppara(n))
n=n+1
fixcost(2)=dexp(ppara(n))
n=n+1
lambda=dexp(ppara(n))
n=n+1
lambdaSS=dexp(ppara(n))

  do i=0,dim_paraCrime
     n=n+1
	 paraCrimePay(i)=ppara(n)
  enddo
    
  do i=1,Ntype
	 n=n+1
	 paraCrime0(i)=ppara(n)
  enddo

  do i=0,3
	 n=n+1
	 paraC(i)=dexp(ppara(n))
  enddo
  
  do i=4,dim_paraC
  	 n=n+1
	 paraC(i)=ppara(n)
  enddo
  
  do i=0,dim_Ujail
	 n=n+1
	 Ujail(i)=ppara(n)
  enddo

  do j=1,Ntype-1
     do i=0,dim_paraP
           n=n+1
	       paraP(i,j)=ppara(n)           
     enddo
  enddo
    
  do i=1,dim_paraTrans
	 n=n+1
	 para_trans(i)=ppara(n)
  enddo
  
  do i=1,dim_paraterminal
     n=n+1
	 para_terminal(i)=ppara(n)
  enddo

  n=n+1
  cut_high(1)=ppara(n)
  
  n=n+1
  cut_public(1)=ppara(n)
  n=n+1
  cut_public(2)=ppara(n)
  n=n+1
  extracost=dexp(ppara(n))
  n=n+1
  lowGPAcost=dexp(ppara(n))
  n=n+1
  morefixcost=dexp(ppara(n))

  cut_prim=0
  


!********** Calculate the type probability for each student, global variable P_ksi
! calculate Betas to interpolate for each student      
allocate (P_ksi(Ntype,dataN),Beta_DPP(dim_betas,bigS2,bigT-1,SizeDimXX,Ntype,Nloc)) 


    do i=1,dataN
	    call Ptype(X(:,i),W(1:6,sch0(i)),P_ksi(1:Ntype-1,i))
	    P_ksi(Ntype,i)=dble(1)-sum(P_ksi(1:Ntype-1,i),dim=1)
	enddo
	
	 Beta_DPP=0.0d-0  
    !$OMP PARALLEL DEFAULT(shared)  private(i,j,n)     
    !$OMP Do  SCHEDULE(dynamic)
    do i=1,SizeDimXX
      do n=1,Nloc
        print*, 'B_emax type of xx and location', i,n
        do j=1,Ntype
	      Beta_DPP(:,:,:,i,j,n)=BEmax(j,X_girdDP(:,i),n)   !Beta_DPP(dim_betas,bigS2,bigT-1,SizeDimXX,Ntype,Nloc)    
	    enddo  
	  enddo
	enddo	
	!$OMP END DO
	!$OMP end PARALLEL

    allocate(shock_gpa(bigT,copies,dataN),shock_prog(bigT,copies,dataN),shock_choice(bigT,copies,dataN),&
               shock_arrest(bigT,copies,dataN),shock_jail(bigT,copies,dataN),shock_transit(copies,dataN),shock_abi(copies,dataN))
!    call rnset(seed) !IMSL
    call sgrnd(seed)
    do j=1,copies
       do ir = 1, dataN
          shock_transit(j,ir) = grnd()
          dummy = grnd()
          call normal_01_cdf_inv(dummy,shock_abi(j,ir))
       end do
       do t=1,bigT
          do ir = 1, dataN
             CALL RANDOM_NUMBER(r_aux); shock_prog(t,j,ir) = r_aux
             CALL RANDOM_NUMBER(r_aux); shock_arrest(t,j,ir) = r_aux
             CALL RANDOM_NUMBER(r_aux); shock_jail(t,j,ir) = r_aux
             CALL RANDOM_NUMBER(r_aux); shock_choice(t,j,ir) = r_aux
             CALL RANDOM_NUMBER(r_aux); dummy = r_aux
             call normal_01_cdf_inv(dummy,shock_gpa(t,j,ir))
          end do
       enddo
    enddo

  
    
    call simulation


end subroutine objective

end module objectives
