subroutine simulation
USE OMP_LIB
use variables
implicit none
integer:: i,c,j,t 
external:: Ptype, updateA
double precision,allocatable:: GPAs(:,:,:)
integer,allocatable:: choices(:,:,:),progs(:,:,:), arrests(:,:,:),jails(:,:,:),newschool(:,:)
double precision:: EA, VA,A1(2,Ntype) !initial beliefs by grade 5 for each type
double precision,allocatable:: ability(:,:) !the assigned true ability for each copy
double precision:: ourA(2,Ntype),temp
double precision,external::  E_GPA, E_S0

!******** Notice: this simulation simulate each replica of the student's behavior, they differ because of type and because of different shocks along the years. 

allocate(choices(bigT,copies,dataN),GPAs(bigT,copies,dataN),progs(bigT+1,copies,dataN),arrests(bigT,copies,dataN), &
jails(bigT,copies,dataN),newschool(copies,dataN),ability(copies,dataN))


	!$OMP PARALLEL DEFAULT(shared)  private(i,c,j,t,EA,VA,A1,temp)     
	!$OMP Do  SCHEDULE(dynamic)
	do i=1,dataN
		!***** obtain the initial beliefs by grade 5 ********
		do j=1,Ntype
		    EA=meanA(j)
		    VA=sigmaA(j)**dble(2)
		    do t=1,dim_oldGPA    !grade 2 to grade 4
                temp=E_GPA(X(:,i),j,W(1:6,sch0(i)),EA,5,1)-EA   !NOTE: we are using the same intercept for grade 5   (may need to change)  
		        call updateA(oldGPA(t,i)-temp,EA,VA,A1(:,j))
		        EA=A1(1,j)
		        VA=A1(2,j)
		    enddo
		    ! our belief about his ability with additional info (s0)
		    temp=E_S0(X(:,i),EA)-EA
		    call updateA_addition(s0(i)-temp,EA,VA,ourA(:,j))
		enddo
		j=1
		do c=1,nint(copies*P_ksi(1,i))
		    ! Assign ability
		    ability(c,i)=ourA(1,j)+ourA(2,j)**dble(0.5)*shock_abi(c,i)
		    
			call student(i,1,c,A1(:,j), ability(c,i),choices(:,c,i),GPAs(:,c,i),progs(:,c,i),arrests(:,c,i),jails(:,c,i),newschool(c,i))
		enddo
		j=2
		do c=nint(copies*P_ksi(1,i))+1,copies
		    ability(c,i)=ourA(1,j)+ourA(2,j)**dble(0.5)*shock_abi(c,i)
			call student(i,2,c,A1(:,j),ability(c,i),choices(:,c,i),GPAs(:,c,i),progs(:,c,i),arrests(:,c,i),jails(:,c,i),newschool(c,i))
		enddo
	enddo
	!$OMP END DO
	!$OMP end PARALLEL

open(1,file='simulateResult1.txt',status='replace')  !write out at the (ID, copy) level
    do i=1,dataN
		do c=1,nint(copies*P_ksi(1,i))
			write(1,100) i,1,c,ability(c,i),choices(:,c,i),GPAs(:,c,i),progs(:,c,i),arrests(:,c,i),jails(:,c,i),newschool(c,i)
		enddo
		do c=nint(copies*P_ksi(1,i))+1,copies
			write(1,100) i,2,c,ability(c,i),choices(:,c,i),GPAs(:,c,i),progs(:,c,i),arrests(:,c,i),jails(:,c,i),newschool(c,i)
		enddo
    enddo
close(1)

	
100 format (I5, I3, I5,F8.3, 8I3,8F8.3,9I3,8I3,8I3,I6) 

print*, 'End Simulation'


end subroutine simulation

