!!********* This subroutine calculates student choice-specific value functions for t<=T, all 4 choices are feasible regardless of last period's decision**********
subroutine values_new(tt, ksi, id, loc, Ea, Va, bigJ, bigG,sch, enrolled, progress, vv)
USE OMP_LIB
use variables
use Emax_int
use random
implicit none
integer, intent(in)::tt, ksi, loc, bigJ(2), bigG, sch,enrolled,progress ,id
!(time period, type, ksi, location, crime history, bigJ: arrest and jail history, grade, school id, whether or not enrolled last period,whether or not to proceed one grade)
! sch: ID of the last school enrolled even if one was not enrolled last period
double precision,intent(in):: Ea, Va !beliefs about ability (mean, variance)
double precision,intent(out):: vv(4) !choice-specific values
integer:: i,t,j,newbigJ(2), id_aux, bigS_loc
double precision:: temp,rho,ss,temp1,GPA0,sigmas, tempcrime,tempedu,sums(2), xx(dim_X)
double precision:: news(2) 
double precision,external:: util, P_pass,E_GPA,p_normal,numerator_trans
double precision:: backC !cost of going back to school
integer:: next_t,tts
integer,parameter:: N_simGPA=100
double precision:: pp(N_simGPA), ff(N_simGPA),pr(N_simGPA),hh(N_simGPA),p_trans(N_sch_loc(loc)), p_trans_vec(bigS),p_trans_s 
double precision:: ww(dim_w)
integer:: bd

CALL RANDOM_SEED(size = i_size)
CALL RANDOM_SEED(put = i_seed)


bigS_loc=N_sch_loc(loc)

if(bigG<Gstar) then
    ww=W(1:dim_w,sch)
else
    ww=W(dim_w+1:dim_w+dim_w,sch)
endif



if(enrolled==0) then 
    backC=fixcost(ksi)
    if(bigJ(1)>0) backC=backC+morefixcost
else
    backC=0.0d-0
endif

vv=-dble(1)
xx=X(:,id)
rho=R_arrest(loc)

id_aux=id_xx(id)

!*** choice=1 (e=0,d=0) *** 
    !EmaxV(id,tt, ksi, xx, loc, Ea, Va, bigJ, bigG,sch, enrolled, progress, age/time period) 
    vv(1)=util(xx,ksi,Ea, WW,progress,loc, bigJ,bigG, 1, tt) +delta*EmaxV(id_aux,tt+1, ksi, xx, loc, Ea, Va,  bigJ,bigG,sch,0, progress) 

    
!*** choice=2 (e=0,d=1)*****
    temp=(1.0d-0-rho)*delta*EmaxV(id_aux,tt+1, ksi, xx, loc, Ea, Va,  bigJ, bigG,sch,0, 0)
        tempcrime=0.0d-0
        newbigJ(1)=bigJ(1)+1
 
        if (tt<bigT) then
           do t=0,maxJ
              newbigJ(2)=bigJ(2)+t
              tts=nint(dble(t)/dble(J_perYear)) !get the rounded number of years spent in jail.
              next_t=min(bigT,tt+tts+1)
              tempcrime=tempcrime+P_Jtime(bigJ(1),t, tt)*delta**dble(tts+1)*EmaxV(id_aux,next_t, ksi, xx, loc, Ea, Va, &
              newbigJ, bigG,sch,0, progress)
           enddo
        else
           do t=0,maxJ
              newbigJ(2)=bigJ(2)+t
              tempcrime=tempcrime+P_Jtime(bigJ(1),t, tt)*delta*EmaxV(id_aux,tt+1, ksi, xx, loc, Ea, Va, newbigJ, bigG,sch,0, &
              progress)
           enddo        	
        end if	
    temp=temp+rho*tempcrime     
    
     vv(2)=util(xx,ksi,Ea, WW,progress,loc, bigJ,bigG, 2,tt)+temp
    
    
        
!*** Choice 3: (e=1,d=0)******  
   
   
   GPA0=E_GPA(xx,ksi,WW,EA,bigG+1,progress)

temp1=GPA0-EA   !f(x,w) part of the GPA, GPA=f(x,w)+a+error
sigmas=(VA+sigma_gpa**dble(2))**dble(0.5)
!ff is for non criminal student, hh is for criminal student
do i=1,N_simGPA
    ss=GPA0+sigmas*random_normal() !we generate normal numbers (given Ea_grid and Va_grid)
    call updateA(ss-temp1,EA,VA,news) !news(1) new EA, news(2) new VA
    pr(i)= P_pass(WW(5),ss,ksi,bigG+1,WW(1))
    
    if(bigG/=Gstar-1) then
        ff(i)=pr(i)*EmaxV(id_aux,tt+1, ksi, xx, loc, news(1),news(2),  bigJ, bigG+1,sch,1, 1) + (1.0d-0-pr(i))*EmaxV(id_aux,tt+1, ksi, &
        xx, loc, news(1),news(2),  bigJ, bigG,sch,1, 0) 
        hh(i)=pr(i)*EmaxV(id_aux,tt+1, ksi, xx, loc, news(1),news(2),  bigJ, bigG+1,sch, 1,1) + (1.0d-0-pr(i))*EmaxV(id_aux,tt+1, ksi, &
        xx, loc, news(1),news(2),  bigJ, bigG,sch,1, 0) 
    else
    	
        do j=1,bigS_loc
            p_trans_vec(j)=numerator_trans(xx,WW,W(7:12,Mat_sch_loc(j,loc)),ss,ksi)            
        enddo
    	p_trans_s=sum(p_trans_vec(1:bigS_loc),dim=1)
    	
    	sums=0.0d-0
        do j=1,bigS_loc
            p_trans(j)=p_trans_vec(j)/p_trans_s
            sums(1)=sums(1)+p_trans(j)*EmaxV(id_aux,tt+1, ksi, xx, loc, news(1),news(2),  bigJ, bigG+1,Mat_sch_loc(j,loc),1, 1) !non crime             ! To fix: now there is no need to have two sum()
            sums(2)=sums(2)+p_trans(j)*EmaxV(id_aux,tt+1, ksi, xx, loc, news(1),news(2),  bigJ, bigG+1,Mat_sch_loc(j,loc),1, 1) !criminals
        enddo
        ff(i)=pr(i)*sums(1) + (1.0d-0-pr(i))*EmaxV(id_aux,tt+1, ksi, xx, loc, news(1),news(2),  bigJ, bigG,sch, 1,0) 
        hh(i)=pr(i)*sums(2) + (1.0d-0-pr(i))*EmaxV(id_aux,tt+1, ksi, xx, loc, news(1),news(2),  bigJ, bigG,sch, 1,0) 
    endif           
enddo
tempedu=sum(ff,dim=1)/dble(N_simGPA)  

    vv(3)=util(xx,ksi,Ea, WW,progress,loc, bigJ,bigG, 3,tt)-backC+tempedu*delta
	
    
    
!*** Choice 4: (e=1,d=1)****** with Eality updating for next period, which depends on the realization of the GPA. 
tempedu=sum(hh,dim=1)/dble(N_simGPA) 
     vv(4)=util(xx,ksi,Ea, WW,progress,loc, bigJ,bigG, 4,tt)-backC+rho*tempcrime+(1.0d-0-rho)*delta*tempedu


end subroutine values_new
